align 16                                                                                                   
UserFileSizeA proc loDword:DWORD,hiDword:DWORD,lpBuffer:DWORD                                              
LOCAL IntPart:DWORD                                                                                        
LOCAL FractPart:DWORD                                                                                      
LOCAL IntStr[11]:BYTE                                                                                      
LOCAL FractStr[11]:BYTE                                                                                    
                                                                                                           
    .data                                                                                                  
        ufs_struc STRUCT                                                                                   
            factor  REAL8 ?                                                                                
            prefix  db 8 dup (?)                                                                           
        ufs_struc ends                                                                                     
                                                                                                           
        align 16                                                                                           
        ufs_bytes       ufs_struc <1.0                  , "Bytes">                                         
        ufs_Kibi        ufs_struc <1024.0               , "KiB"  >                                         
        ufs_Mebi        ufs_struc <1048576.0            , "MiB"  >                                         
        ufs_Gibi        ufs_struc <1073741824.0         , "GiB"  >                                         
        ufs_Tebi        ufs_struc <1099511627776.0      , "TiB"  >                                         
        ufs_Pebi        ufs_struc <1125899906842624.0   , "PiB"  >                                         
        ufs_Exbi        ufs_struc <1152921504606846976.0, "EiB"  >                                         
                                                                                                           
        ufs_zero_bytes db "0 Bytes",0                                                                      
                                                                                                           
        align 16                                                                                           
        ufs_const REAL8 10.0                                                                               
        ufs_point db ".",0                                                                                 
        ufs_space db " ",0                                                                                 
                                                                                                           
    .code                                                                                                  
                                                                                                           
    finit                                                                                                  
                                                                                                           
    test hiDword,0FFFFFFFFh                                                                                
    .if ZERO?                                                                                              
        mov eax,loDword                                                                                    
        bsr edx,eax                                                                                        
        .if !ZERO?                                                                                         
            .if edx >= 30                           ;=> GiB                                                
                mov edx,eax                                                                                
                shr eax,30                                                                                 
                and edx,3FFFFFFFh                                                                          
                mov IntPart,eax                                                                            
                                                                                                           
                mov loDword,edx                                                                            
                mov hiDword,0                                                                              
                fld ufs_Gibi.factor                                                                        
                fild QWORD ptr loDword                                                                     
                fdiv st(0),st(1)                                                                           
                fld ufs_const                                                                              
                fmul st(0),st(1)                                                                           
                fist FractPart                                                                             
                .if FractPart > 9                                                                          
                    inc IntPart                                                                            
                    mov FractPart,0                                                                        
                .endif                                                                                     
                                                                                                           
                mov edx,OFFSET ufs_Gibi.prefix                                                             
                                                                                                           
            .elseif edx >= 20                       ;=> MiB                                                
                mov edx,eax                                                                                
                shr eax,20                                                                                 
                and edx,0FFFFFh                                                                            
                mov IntPart,eax                                                                            
                                                                                                           
                mov loDword,edx                                                                            
                mov hiDword,0                                                                              
                fld ufs_Mebi.factor                                                                        
                fild QWORD ptr loDword                                                                     
                fdiv st(0),st(1)                                                                           
                fld ufs_const                                                                              
                fmul st(0),st(1)                                                                           
                fist FractPart                                                                             
                .if FractPart > 9                                                                          
                    inc IntPart                                                                            
                    mov FractPart,0                                                                        
                .endif                                                                                     
                                                                                                           
                mov edx,OFFSET ufs_Mebi.prefix                                                             
                                                                                                           
            .elseif edx >= 10                       ;=> KiB                                                
                mov edx,eax                                                                                
                shr eax,10                                                                                 
                and edx,03FFh                                                                              
                mov IntPart,eax                                                                            
                                                                                                           
                mov loDword,edx                                                                            
                mov hiDword,0                                                                              
                fld ufs_Kibi.factor                                                                        
                fild QWORD ptr loDword                                                                     
                fdiv st(0),st(1)                                                                           
                fld ufs_const                                                                              
                fmul st(0),st(1)                                                                           
                fist FractPart                                                                             
                .if FractPart > 9                                                                          
                    inc IntPart                                                                            
                    mov FractPart,0                                                                        
                .endif                                                                                     
                                                                                                           
                mov edx,OFFSET ufs_Kibi.prefix                                                             
                                                                                                           
            .else                                   ;=> bytes                                              
                mov FractPart,0                                                                            
                mov eax,loDword                                                                            
                mov IntPart,eax                                                                            
                mov edx,OFFSET ufs_bytes.prefix                                                            
            .endif                                                                                         
            push edx                                                                                       
            invoke dwtoa,IntPart,ADDR IntStr                                                               
            invoke dwtoa,FractPart,ADDR FractStr                                                           
            pop edx                                                                                        
            invoke szMultiCat,5,lpBuffer,ADDR IntStr,OFFSET ufs_point,ADDR FractStr,OFFSET ufs_space,edx   
                                                                                                           
                                                                                                           
        .else                                       ;=> null-bytes                                         
                                                                                                           
            invoke szCopy,OFFSET ufs_zero_bytes,lpBuffer                                                   
        .endif                                                                                             
    .else                                                                                                  
        mov eax,hiDword                                                                                    
        bsr edx,eax                                                                                        
        .if edx >= 28                               ;=> EiB                                                
            mov edx,eax                                                                                    
            shr eax,28                                                                                     
            and edx,0FFFFFFFh                                                                              
            mov IntPart,eax                                                                                
                                                                                                           
            mov hiDword,edx                                                                                
            fld ufs_Exbi.factor                                                                            
            fild QWORD ptr loDword                                                                         
            fdiv st(0),st(1)                                                                               
            fld ufs_const                                                                                  
            fmul st(0),st(1)                                                                               
            fist FractPart                                                                                 
            .if FractPart > 9                                                                              
                inc IntPart                                                                                
                mov FractPart,0                                                                            
            .endif                                                                                         
                                                                                                           
            mov edx,OFFSET ufs_Exbi.prefix                                                                 
                                                                                                           
        .elseif edx >= 18                           ;=> PiB                                                
            mov edx,eax                                                                                    
            shr eax,18                                                                                     
            and edx,03FFFFh                                                                                
            mov IntPart,eax                                                                                
                                                                                                           
            mov hiDword,edx                                                                                
            fld ufs_Pebi.factor                                                                            
            fild QWORD ptr loDword                                                                         
            fdiv st(0),st(1)                                                                               
            fld ufs_const                                                                                  
            fmul st(0),st(1)                                                                               
            fist FractPart                                                                                 
            .if FractPart > 9                                                                              
                inc IntPart                                                                                
                mov FractPart,0                                                                            
            .endif                                                                                         
                                                                                                           
            mov edx,OFFSET ufs_Pebi.prefix                                                                 
                                                                                                           
        .elseif edx >= 8                            ;=> TiB                                                
            mov edx,eax                                                                                    
            shr eax,8                                                                                      
            and edx,0FFh                                                                                   
            mov IntPart,eax                                                                                
                                                                                                           
            mov hiDword,edx                                                                                
            fld ufs_Tebi.factor                                                                            
            fild QWORD ptr loDword                                                                         
            fdiv st(0),st(1)                                                                               
            fld ufs_const                                                                                  
            fmul st(0),st(1)                                                                               
            fist FractPart                                                                                 
            .if FractPart > 9                                                                              
                inc IntPart                                                                                
                mov FractPart,0                                                                            
            .endif                                                                                         
                                                                                                           
            mov edx,OFFSET ufs_Tebi.prefix                                                                 
                                                                                                           
        .else                                       ;=> GiB                                                
                                                                                                           
            mov edx,loDword                                                                                
            shl eax,2                                                                                      
            mov ecx,edx                                                                                    
            shr edx,30                                                                                     
            or eax,edx                                                                                     
            and ecx,3FFFFFFFh                                                                              
            mov IntPart,eax                                                                                
                                                                                                           
            mov loDword,ecx                                                                                
            mov hiDword,0                                                                                  
            fld ufs_Gibi.factor                                                                            
            fild QWORD ptr loDword                                                                         
            fdiv st(0),st(1)                                                                               
            fld ufs_const                                                                                  
            fmul st(0),st(1)                                                                               
            fist FractPart                                                                                 
            .if FractPart > 9                                                                              
                inc IntPart                                                                                
                mov FractPart,0                                                                            
            .endif                                                                                         
                                                                                                           
            mov edx,OFFSET ufs_Gibi.prefix                                                                 
                                                                                                           
        .endif                                                                                             
        push edx                                                                                           
        invoke dwtoa,IntPart,ADDR IntStr                                                                   
        invoke dwtoa,FractPart,ADDR FractStr                                                               
        pop edx                                                                                            
        invoke szMultiCat,5,lpBuffer,ADDR IntStr,OFFSET ufs_point,ADDR FractStr,OFFSET ufs_space,edx       
                                                                                                           
    .endif                                                                                                 
                                                                                                           
    ret                                                                                                    
                                                                                                           
UserFileSizeA endp        